#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool secenje(vector<long long>& duzine, long long isecena, int n) {
    vector<long long> preostale;

    for (int i = 0; i < n; i++) {
        if (duzine[i] < isecena) {
            preostale.push_back(duzine[i]);
        }
    }

    sort(preostale.begin(), preostale.end(), greater<long long>());

    int brojpreostalih = preostale.size();
    int k = 1;

    for (int i = 0; i < brojpreostalih; i++) {
        if (preostale[i] * k >= isecena) {
            k++;
        } else {
            break;
        }
    }

    return k >= n;
}

long long makssecenje(vector<long long>& duzine, int n) {
    long long levo = 1;
    long long desno = *max_element(duzine.begin(), duzine.end());

    while (levo < desno) {
        long long sredina = levo + (desno - levo) / 2;

        if (secenje(duzine, sredina, n)) {
            levo = sredina + 1;
        } else {
            desno = sredina;
        }
    }

    return levo - 1;
}

int main() {
    int n;
    cin >> n;

    vector<long long> duzine(n);

    for (int i = 0; i < n; i++) {
        cin >> duzine[i];
    }

    long long rezultat = makssecenje(duzine, n);

    cout << rezultat << endl;

    return 0;
}